Subject: Equally capable referrals

From: "Jim Sermersheim" <[email-masked]>
Date: Mon, 05 Nov 2001 17:57:31 -0700

Earlier we discussed the issue of "what does it mean for referrals to be equally capable of being used to progress an operation?" (See section 4.1.11 in RFC 2251)

My belief is that this requirement cannot be enforced. Especially if we allow the naming model to incorporate referral objects that may be added by an administrator. If the DSA is to follow referrals that an administrator was allowed to populate, it effectively puts the MUST requirement on the administrator, which I don't think was the original intent of the RFC.

Earlier, we had rough consensus on dropping the word "equally", but how does one control whether the URL populated in a referral are capable at all of progressing the operation?

Either by consensus, or lack of two interoperable implementations, I would like to remove the sentence altogether--along with the sentence that directly follows (which indicates that we don't really know how to enforce the requirement anyway).

Novell has an implementation that I believe follows the intent of the statement, but it does so by using a special protocol to add referrals--which is NOT at all in line with manageDSAIT and the referral object.

So, does anyone believe this statement should not be removed? If so, can you illustrate through the example of an implementation what it means, and how it may be achieved?

Jim

---

From: "Jim Sermersheim" <[email-masked]>
Date: Tue, 06 Nov 2001 18:28:57 -0700

Yes, I would prefer to reflect that there is no mechanism (within the referral) to 'weight' the referrals, thus any referral may be used to progress the operation. This doesn't prevent the client from imposing its own heuristics. 

I don't like implying that *some process* is absolutely responsible to somehow ensure the validity of the referrals.

Jim

>>> "Kurt D. Zeilenga" <[email-masked]> 11/06/01 06:02PM >>>
At 04:01 PM 2001-11-06, Jim Sermersheim wrote:
>This explains the intent of equally capable nicely, but my bigger question is: Who's responsibility is it to enforce the "MUSTness" of the statement? 

Well, given the wording of this particular MUST, it appears to
be server obligation return "equally capable" URLs.  Of course,
if the server uses namedref or dnsref or some other administrative
mechanism, then it server implementation really defers this
obligation to the deployer / administrator.

I think MUST and "equally capable" are a bit strong.
The key is that there is no preferred order and regardless of
which one service is contacted, that service should be
capable of furthering the operation towards completion.
Note the distinction between "completing the operation"
as opposed to "furthering the operation towards completion".
One must allowed the referred to server to return a referral.

---

From: "Timothy Hahn" <[email-masked]>
Date: Tue, 6 Nov 2001 21:54:15 -0500

So, in summary, it sounds like we have concensus on striking the sentence 
about "equally capable" and relying on the verbage around it to indicate 
the intent of the referral concept.

Regards,
Tim Hahn

Internet: [email-masked]
Internal: Timothy Hahn/Endicott/IBM@IBMUS or IBMUSM00(HAHNT)
phone: 607.752.6388     tie-line: 8/852.6388
fax: 607.752.3681

"Jim Sermersheim" <[email-masked]>
11/06/2001 08:28 PM

        To:     <[email-masked]>
        cc:     "Steve Sonntag" <[email-masked]>, 
<[email-masked]>, <[email-masked]>, Timothy 
Hahn/Endicott/IBM@IBMUS
        Subject:        Re: Equally capable referrals

Yes, I would prefer to reflect that there is no mechanism (within the 
referral) to 'weight' the referrals, thus any referral may be used to 
progress the operation. This doesn't prevent the client from imposing its 
own heuristics. 

I don't like implying that *some process* is absolutely responsible to 
somehow ensure the validity of the referrals.

Jim

At 04:01 PM 2001-11-06, Jim Sermersheim wrote:
>This explains the intent of equally capable nicely, but my bigger 
question is: Who's responsibility is it to enforce the "MUSTness" of the 
statement?